<?php
/**
 * ipasspay_direct Payment Module
 * contact: tech@ipasspay.com
 * @package paymentMethod
 * @copyright Copyright 2003-2010 Zen Cart Development Team
 * @copyright Portions Copyright 2003 osCommerce
 * @license http://www.zen-cart.com/license/2_0.txt GNU Public License V2.0
 * @version $Id: ipasspay_direct.php 15420 2010-02-04 21:27:05Z drbyte $
 */
class ipasspay_direct {
    var $code, $title, $description, $enabled, $auth_status, $comment;

    // class constructor
    function ipasspay_direct() {
        global $order;

        $this->title = MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CATALOG_TITLE;
        $this->code = 'ipasspay_direct';
        $this->description = MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_DESCRIPTION;
        $this->sort_order = MODULE_PAYMENT_IPASSPAY_DIRECT_SORT_ORDER;
        $this->enabled = ((MODULE_PAYMENT_IPASSPAY_DIRECT_STATUS == 'True') ? true : false);

        if ((int) MODULE_PAYMENT_IPASSPAY_DIRECT_ORDER_STATUS_ID > 0) {
            $this->order_status = MODULE_PAYMENT_IPASSPAY_DIRECT_ORDER_STATUS_ID;
        }

        if (is_object($order)) {
            $this->update_status();
        }

    }

    // class methods
    function update_status() {
        global $order, $db;

        if (($this->enabled == true) && ((int) MODULE_PAYMENT_IPASSPAY_DIRECT_ZONE > 0)) {
            $check_flag = false;
            $check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_IPASSPAY_DIRECT_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
            while (!$check->EOF) {
                if ($check->fields['zone_id'] < 1) {
                    $check_flag = true;
                    break;
                } elseif ($check->fields['zone_id'] == $order->delivery['zone_id']) {
                    $check_flag = true;
                    break;
                }
                $check->MoveNext();
            }

            if ($check_flag == false) {
                $this->enabled = false;
            }
        }

        // disable the module if the order only contains virtual products
        if ($this->enabled == true) {
            if ($order->content_type != 'physical') {
                $this->enabled = false;
            }
        }
    }

    function javascript_validation() {
        $js = '  if (payment_value == "' . $this->code . '") {' . "\n" .
            '    var cc_owner = document.checkout_payment.ipasspay_direct_cc_owner.value;' . "\n" .
            '    var cc_number = document.checkout_payment.ipasspay_direct_cc_number.value;' . "\n" .
            '    var cc_cvv = document.checkout_payment.ipasspay_direct_cc_cvv.value;' . "\n" .
            '    if (cc_owner == "" || cc_owner.length < ' . CC_OWNER_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_JS_CC_OWNER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '    if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {' . "\n" .
            '      error_message = error_message + "' . MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_JS_CC_NUMBER . '";' . "\n" .
            '      error = 1;' . "\n" .
            '    }' . "\n" .
            '         if (cc_cvv == "" || cc_cvv.length < "3") {' . "\n" .
            '           error_message = error_message + "' . MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_JS_CC_CVV . '";' . "\n" .
            '           error = 1;' . "\n" .
            '         }' . "\n" .
            '  }' . "\n";

        return $js;
    }

    // Display Credit Card Information Submission Fields on the Checkout Payment Page
    function selection() {
        global $order;

        for ($i = 1; $i < 13; $i++) {
            $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B - (%m)', mktime(0, 0, 0, $i, 1, 2000)));
        }

        $today = getdate();
        for ($i = $today['year']; $i < $today['year'] + 15; $i++) {
            $expires_year[] = array('id' => strftime('%y', mktime(0, 0, 0, 1, 1, $i)), 'text' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)));
        }

        $onFocus = ' onfocus="methodSelect(\'pmt-' . $this->code . '\')"';

        $selection = array('id' => $this->code,
            'module' => $this->title,
            'fields' => array( /*array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CREDIT_CARD_OWNER,
	                                                 'field' => zen_draw_input_field('ipasspay_direct_cc_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname'], 'id="'.$this->code.'-cc-owner"'. $onFocus . ' autocomplete="off"'),
					*/
                array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_ADMIN_TITLE,
                    'field' => '',),
                array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CREDIT_CARD_NUMBER,
                    'field' => zen_draw_input_field('ipasspay_direct_cc_number', $ccnum, 'id="' . $this->code . '-cc-number"' . $onFocus . ' autocomplete="off"'),
                    'tag' => $this->code . '-cc-number'),
                array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CREDIT_CARD_EXPIRES,
                    'field' => zen_draw_pull_down_menu('ipasspay_direct_cc_expires_month', $expires_month, strftime('%m'), 'id="' . $this->code . '-cc-expires-month"' . $onFocus) . '&nbsp;' . zen_draw_pull_down_menu('ipasspay_direct_cc_expires_year', $expires_year, '', 'id="' . $this->code . '-cc-expires-year"' . $onFocus),
                    'tag' => $this->code . '-cc-expires-month'),
                array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CVV,
                    'field' => zen_draw_input_field('ipasspay_direct_cc_cvv', '', 'size="4" maxlength="4"' . ' id="' . $this->code . '-cc-cvv"' . $onFocus . ' autocomplete="off"') . ' ' . '<a href="javascript:popupWindow(\'' . zen_href_link(FILENAME_POPUP_CVV_HELP) . '\')">' . MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_POPUP_CVV_LINK . '</a>',
                    'tag' => $this->code . '-cc-cvv')));

        return $selection;
    }

    function pre_confirmation_check() {
        global $db, $messageStack;

        include DIR_WS_CLASSES . 'cc_validation.php';

        $cc_validation = new cc_validation();
        $result = $cc_validation->validate($_POST['ipasspay_direct_cc_number'], $_POST['ipasspay_direct_cc_expires_month'], $_POST['ipasspay_direct_cc_expires_year']);
        $error = '';
        switch ($result) {
            case -1:
                $error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->cc_number, 0, 4));
                break;
            case -2:
            case -3:
            case -4:
                $error = TEXT_CCVAL_ERROR_INVALID_DATE;
                break;
            case false:
                $error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
                break;
        }

        // save record of errors which occur during checkout_payment validation phase but haven't been sent to gateway yet
        if (($result == false) || ($result < 1)) {
            $payment_error_return = 'payment_error=' . $this->code;
            $error_info2 = '&error=' . urlencode($error) . '&ipasspay_direct_cc_owner=' . urlencode($_POST['ipasspay_direct_cc_owner']) . '&ipasspay_direct_cc_expires_month=' . $_POST['ipasspay_direct_cc_expires_month'] . '&ipasspay_direct_cc_expires_year=' . $_POST['ipasspay_direct_cc_expires_year'];
            $messageStack->add_session('checkout_payment', $error . '<!-- [' . $this->code . '] -->', 'error');
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
        }

        // if no error, continue with validated data:
        $this->cc_card_type = $cc_validation->cc_type;
        $this->cc_card_number = $cc_validation->cc_number;
        $this->cc_expiry_month = $cc_validation->cc_expiry_month;
        $this->cc_expiry_year = $cc_validation->cc_expiry_year;
    }

    function confirmation() {
        // $confirmation = array('title' => $this->title . ': ' . $this->cc_card_type,
        //                       'fields' => array(array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CREDIT_CARD_OWNER,
        //                                               'field' => $_POST['ipasspay_direct_cc_owner']),
        //                                         array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CREDIT_CARD_NUMBER,
        //                                               'field' => str_repeat('X', (strlen($this->cc_card_number) - 4)) . substr($this->cc_card_number, -4)),
        //                                         array('title' => MODULE_PAYMENT_IPASSPAY_DIRECT_TEXT_CREDIT_CARD_EXPIRES,
        //                                               'field' => strftime('%B, %Y', mktime(0,0,0,$_POST['ipasspay_direct_cc_expires_month'], 1, '20' . $_POST['ipasspay_direct_cc_expires_year'])))));
        //
        // return $confirmation;
        return false;
    }

    function process_button() {
        // These are hidden fields on the checkout confirmation page
        $process_button_string = /*zen_draw_hidden_field('cc_owner', $_POST['ipasspay_direct_cc_owner']) .*/
            zen_draw_hidden_field('cc_expires', $this->cc_expiry_month . substr($this->cc_expiry_year, -2)) .
            zen_draw_hidden_field('cc_expires_month', $this->cc_expiry_month) .
            zen_draw_hidden_field('cc_expires_year', substr($this->cc_expiry_year, -2)) .
            zen_draw_hidden_field('cc_type', $this->cc_card_type) .
            zen_draw_hidden_field('cc_number', $this->cc_card_number) .
            zen_draw_hidden_field('cc_cvv', $_POST['ipasspay_direct_cc_cvv']) .
            zen_draw_hidden_field('cc_uuid', $this->create_guid());
        $process_button_string .= zen_draw_hidden_field(zen_session_name(), zen_session_id());
        return $process_button_string;
    }

    /**
     * Prepare and submit the authorization to the gateway
     */
    function before_process() {
        //var_dump($_REQUEST);exit;
    }

    /**
     * the function for creating uuid in PHP
     */
    function create_guid() {
        $charid = strtoupper(md5(uniqid(mt_rand(), true)));
        $hyphen = chr(45); // "-"
        $uuid = substr($charid, 0, 8) . $hyphen
            . substr($charid, 8, 4) . $hyphen
            . substr($charid, 12, 4) . $hyphen
            . substr($charid, 16, 4) . $hyphen
            . substr($charid, 20, 12);
        return $uuid;
    }

    function after_process() {
        //var_dump($_REQUEST);exit;
        //zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
        //exit;

        global $insert_id, $db, $order, $messageStack;

        /*
            执行到这里，订单已经生成，这个时候，将订单和支付数据提交到网关
        */
        $amount = $order->info['total'] * $order->info['currency_value'];
        $amount = number_format($amount, 2, '.', '');

        $merchant_id = MODULE_PAYMENT_IPASSPAY_DIRECT_MERCHANT_ID;
        $app_id = MODULE_PAYMENT_IPASSPAY_DIRECT_APP_ID;
        $api_secret = MODULE_PAYMENT_IPASSPAY_DIRECT_API_SECRET;
        $gateway_url = MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY;
        $gateway_version = MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY_VERSION;
        $asyn_url = MODULE_PAYMENT_IPASSPAY_DIRECT_ASYN_NOTIFY;

        $curlPost['merchant_id'] = $merchant_id;
        $curlPost['app_id'] = $app_id;
        $curlPost['order_no'] = time() . rand(11,99)."zencart".$insert_id;
        $curlPost['order_currency'] = $order->info['currency'];
        $curlPost['order_amount'] = $amount;
        $curlPost['order_items'] = 'goods';

        $curlPost['card_no'] = $_POST['cc_number'];
        $curlPost['card_ex_year'] = $_POST['cc_expires_year'];
        $curlPost['card_ex_month'] = $_POST['cc_expires_month']; //信用卡过期月
        $curlPost['card_cvv'] = $_POST['cc_cvv']; //信用卡CVV
        $curlPost['source_ip'] = ($this->getIP()=='::1')?'127.0.0.1':$this->getIP();
        $curlPost['source_url'] = $this->curPageURL();
        $curlPost['asyn_notify_url'] = $asyn_url;
        $curlPost['syn_notify_url'] = $this->curPageURL();
        $curlPost['version'] = $gateway_version;
        $curlPost['signature'] = hash('sha256', $curlPost['merchant_id'] . $curlPost['app_id']  . $curlPost['order_no'] . $curlPost['order_amount'] . $curlPost['order_currency'] . $api_secret);

        //billing
        $curlPost['bill_firstname'] = $order->billing['firstname'];
        $curlPost['bill_lastname'] = $order->billing['lastname'];
        $curlPost['bill_email'] = $order->customer['email_address'];
        $curlPost['bill_phone'] = $order->customer['telephone'];
        $curlPost['bill_country'] = $order->billing['country']['iso_code_2'];
        $curlPost['bill_state'] = zen_get_zone_code($order->customer['country']['id'], $order->customer['zone_id'], $order->customer['state']);
        $curlPost['bill_city'] = $order->billing['city'];
        $curlPost['bill_street'] = $order->billing['street_address'];
        $curlPost['bill_zip'] = $order->billing['postcode'];

        //shipping
        $curlPost['ship_firstname'] = $order->delivery['firstname'];
        $curlPost['ship_lastname'] = $order->delivery['lastname'];
        $curlPost['ship_email'] = $order->customer['email_address'];
        $curlPost['ship_phone'] = $order->customer['telephone'];
        $curlPost['ship_country'] = $order->delivery['country']['iso_code_2'];
        $curlPost['ship_state'] =  zen_get_zone_code($order->delivery['country']['id'], $order->delivery['zone_id'], $order->delivery['state']);
        $curlPost['ship_city'] = $order->delivery['city'];
        $curlPost['ship_street'] = $order->delivery['street_address'];
        $curlPost['ship_zip'] = $order->delivery['postcode'];
        $curlPost['custom_data'] = $insert_id;
        $curlPost['lang'] = 'en-us'; //zh-cn en-us

        $response = $this->curlSend($gateway_url,$curlPost,1);
        //echo $response;exit;

        /*
         * 至此，提交过程结束，如果返回为空，则返回提交支付界面
        */
        if ($response == "") {
            //修改订单为失败
            $comment = "Invalid response,please try again.";
            //$auth_status = $this->order_status + 2;
            $auth_status = 7;
            $messageStack->add_session('checkout_payment', $comment, 'caution');
            //修改交易状态和说明
            $this->update_order_info($insert_id, $auth_status, $comment);
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
        }

        //解析返回的JSON
        $back_data = json_decode($response,true);

        if ($back_data['errcode'] == 0) {
            //3D跳转
            if ($back_data['data']['pay_url'] != '') {
                //返回的说明
                $comment = 'Pending';
                //修改订单为不变
                $auth_status = 1;
                //清空购物车
                unset($_SESSION['order_summary']);
                unset($_SESSION['order_number_created']);
                $_SESSION['cart']->reset(true);

                //加入订单历史
                $sql_data_array = array(array('fieldName' => 'orders_id', 'value' => $insert_id, 'type' => 'integer'),
                    array('fieldName' => 'orders_status_id', 'value' => $auth_status, 'type' => 'integer'),
                    array('fieldName' => 'date_added', 'value' => 'now()', 'type' => 'noquotestring'),
                    array('fieldName' => 'customer_notified', 'value' => 1, 'type' => 'integer'),
                    array('fieldName' => 'comments', 'value' => $comment, 'type' => 'string'));
                $db->perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

                //修改交易状态和说明
                $sql_data_array = array('orders_status' => $auth_status,
                    'orders_date_finished' => 'now()',
                );
                zen_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . (int) $insert_id); //更新订单状态

                $redirect_url = urldecode($back_data['data']['pay_url']);
                header("Location: $redirect_url");
                exit;

            } else {
                //2D
                switch ($back_data['data']['order_status']) {
                    case '2'://成功
                    case '4'://授权
                        //返回的说明
                        $comment = 'Payment success';
                        //修改订单为成功
                        //$auth_status = $this->order_status + 1;
                        $auth_status = 2;
                        //清空购物车
                        unset($_SESSION['order_summary']);
                        unset($_SESSION['order_number_created']);
                        $_SESSION['cart']->reset(true);
                        break;
                    case '3'://失败
                        //返回的说明
                        $comment = $back_data['data']['info'];
                        //交易失败
                        //$auth_status = $this->order_status + 2;
                        $auth_status = 7;
                        $messageStack->add_session('checkout_payment', $comment, 'caution');
                        break;
                    default:
                        break;
                }
            }

        } else {
            //返回的说明
            $comment = $back_data['errmsg'];
            //交易失败
            //$auth_status = $this->order_status + 2;
            $auth_status = 7;
            $messageStack->add_session('checkout_payment', $comment, 'caution');
        }


        //加入订单历史
        $sql_data_array = array(array('fieldName' => 'orders_id', 'value' => $insert_id, 'type' => 'integer'),
            array('fieldName' => 'orders_status_id', 'value' => $auth_status, 'type' => 'integer'),
            array('fieldName' => 'date_added', 'value' => 'now()', 'type' => 'noquotestring'),
            array('fieldName' => 'customer_notified', 'value' => 1, 'type' => 'integer'),
            array('fieldName' => 'comments', 'value' => $comment, 'type' => 'string'));
        $db->perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

        //修改交易状态和说明
        $sql_data_array = array('orders_status' => $auth_status,
            'orders_date_finished' => 'now()',
        );
        zen_db_perform(TABLE_ORDERS, $sql_data_array, 'update', 'orders_id = ' . (int) $insert_id); //更新订单状


        if ($auth_status == 2) {
            //交易成功
            $notify_html = $this->getNotifyHtml('success',$insert_id);

        } elseif ($auth_status == 7) {
            //交易失败
            //zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
            $notify_html = $this->getNotifyHtml('decline',$insert_id);

        } else {
            $notify_html = $this->getNotifyHtml('pending',$insert_id);
        }
        echo $notify_html;
        exit;
    }

    function after_order_create($zf_order_id) {
        //echo $zf_order_id;
        //var_dump($_REQUEST);
        //exit;
        // global $db, $lp_avs, $lp_trans_num;
        //$db->execute("update "  . TABLE_ORDERS . " set lp_avs ='" . $lp_avs . "' where orders_id = '" . $zf_order_id ."'");
        //$db->execute("update "  . TABLE_ORDERS . " set lp_trans_num ='" . $lp_trans_num . "' where orders_id = '" . $zf_order_id ."'");
        // $db->execute("update "  . TABLE_LINKPOINT_API . " set order_id ='" . $zf_order_id . "' where lp_trans_num = '" . $lp_trans_num ."'");
    }

    function get_error() {
        return false;
    }

    function check() {
        global $db;
        if (!isset($this->_check)) {
            $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_IPASSPAY_DIRECT_STATUS'");
            $this->_check = $check_query->RecordCount();
        }
        return $this->_check;
    }

    function install() {
        global $db, $messageStack;
        if (defined('MODULE_PAYMENT_IPASSPAY_DIRECT_STATUS')) {
            $messageStack->add_session('IPASSPAY_DIRECT module already installed.', 'error');
            zen_redirect(zen_href_link(FILENAME_MODULES, 'set=payment&module=ipasspay_direct', 'NONSSL'));
            return 'failed';
        }

        //查看订单状态里有没有Success[ipasspay_direct]的状态
        $check_query = $db->Execute("select orders_status_id from " . TABLE_ORDERS_STATUS .
            " where orders_status_name = 'Pending[ipasspay_direct]' limit 1");

        //如果记录条数小于1，那么就安装的时候就要加上这个状态
        if ($check_query->RecordCount() < 1) {
            $status_query = $db->Execute("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);

            $status_id = $status_query->fields['status_id'] + 1;
            $languages = zen_get_languages();

            $pending_status = $status_id; //pending
            $success_status = $status_id + 1; //成功
            $failed_status = $status_id + 2; //失败

            foreach ($languages as $lang) //为所有语言版本设置一样的订单状态
            {
                $db->Execute("insert into " . TABLE_ORDERS_STATUS . "
				(orders_status_id, language_id, orders_status_name) values
				('" . $pending_status . "', '" . $lang['id'] . "', 'Pending[ipasspay_direct]')");

                $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (
				orders_status_id, language_id, orders_status_name) values
				('" . $success_status . "', '" . $lang['id'] . "', 'Success[ipasspay_direct]')");

                $db->Execute("insert into " . TABLE_ORDERS_STATUS . " (
				orders_status_id, language_id, orders_status_name) values
				('" . $failed_status . "', '" . $lang['id'] . "', 'Failed[ipasspay_direct]')");
            }

        }

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable IPASSPAY_DIRECT credit card payment Module', 'MODULE_PAYMENT_IPASSPAY_DIRECT_STATUS', 'True', 'Do you want to accept IPASSPAY_DIRECT payments?', '6', '1', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now())");

        //商户ID
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
	  configuration_key,
	  configuration_value,
	  configuration_description,
	  configuration_group_id,
	  sort_order,
	  date_added) values (
	  		  'Merchant id',
	  		  'MODULE_PAYMENT_IPASSPAY_DIRECT_MERCHANT_ID',
	  		  '',
	  		  'Merchant id of IPASSPAY_DIRECT account',
	  		  '6',
	  		  '0',
	  		  now())");

        //APP ID
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
		  configuration_key,
		  configuration_value,
		  configuration_description,
		  configuration_group_id,
		  sort_order,
		  date_added) values (
		  			  'App ID',
		  			  'MODULE_PAYMENT_IPASSPAY_DIRECT_APP_ID',
		  			  '',
		  			  'App ID of IPASSPAY_DIRECT account',
		  			  '6',
		  			  '0',
		  			  now())");

        //API_SECRET
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
			  configuration_key,
			  configuration_value,
			  configuration_description,
			  configuration_group_id,
			  sort_order,
			  date_added) values (
			  				  'API Secret',
			  				  'MODULE_PAYMENT_IPASSPAY_DIRECT_API_SECRET',
			  				  '',
			  				  'API Secret of IPASSPAY_DIRECT account',
			  				  '6',
			  				  '0',
			  				  now())");
        //GATEWAY
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
			  configuration_key,
			  configuration_value,
			  configuration_description,
			  configuration_group_id,
			  sort_order,
			  date_added) values (
			  				  'GATEWAY URL',
			  				  'MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY',
			  				  '',
			  				  'default:https://service.ipasspay.biz/gateway/OpenApi/onlinePay',
			  				  '6',
			  				  '0',
			  				  now())");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
			  configuration_key,
			  configuration_value,
			  configuration_description,
			  configuration_group_id,
			  sort_order,
			  date_added) values (
			  				  'GATEWAY VERSION',
			  				  'MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY_VERSION',
			  				  '',
			  				  'default:1.0',
			  				  '6',
			  				  '0',
			  				  now())");

        //Notify Url
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title,
			  configuration_key,
			  configuration_value,
			  configuration_description,
			  configuration_group_id,
			  sort_order,
			  date_added) values (
			  				  'Notify URL',
			  				  'MODULE_PAYMENT_IPASSPAY_DIRECT_ASYN_NOTIFY',
			  				  '',
			  				  'default:https://www.yourdomain.com/index.php?main_page=ipasspay_direct',
			  				  '6',
			  				  '0',
			  				  now())");


        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_IPASSPAY_DIRECT_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_IPASSPAY_DIRECT_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_IPASSPAY_DIRECT_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
    }

    function remove() {
        global $db;
        $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
        //删除ipasspay_direct的成功和失败状态
        $db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Pending[ipasspay_direct]' ");
        $db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Success[ipasspay_direct]' ");
        $db->Execute("delete from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Failed[ipasspay_direct]' ");
    }

    function keys() {
        return array('MODULE_PAYMENT_IPASSPAY_DIRECT_STATUS',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_MERCHANT_ID',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_APP_ID',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_API_SECRET',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_GATEWAY_VERSION',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_ASYN_NOTIFY',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_ZONE',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_ORDER_STATUS_ID',
            'MODULE_PAYMENT_IPASSPAY_DIRECT_SORT_ORDER');
    }

    function curPageURL()
    {
        $pageURL = 'http';

        if ($_SERVER["HTTPS"] == "on")
        {
            $pageURL .= "s";
        }
        $pageURL .= "://";

        if ($_SERVER["SERVER_PORT"] != "80")
        {
            $pageURL .= $_SERVER["SERVER_NAME"] . ":" . $_SERVER["SERVER_PORT"];
        }
        else
        {
            $pageURL .= $_SERVER["SERVER_NAME"];
        }
        return $pageURL;
    }

    function getIP()
    {
        static $realip;
        if (isset($_SERVER)){
            if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])){
                $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
            } else if (isset($_SERVER["HTTP_CLIENT_IP"])) {
                $realip = $_SERVER["HTTP_CLIENT_IP"];
            } else {
                $realip = $_SERVER["REMOTE_ADDR"];
            }
        } else {
            if (getenv("HTTP_X_FORWARDED_FOR")){
                $realip = getenv("HTTP_X_FORWARDED_FOR");
            } else if (getenv("HTTP_CLIENT_IP")) {
                $realip = getenv("HTTP_CLIENT_IP");
            } else {
                $realip = getenv("REMOTE_ADDR");
            }
        }
        return $realip;
    }

    function curlSend($process_gateway, $data_arr, $type = 1) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $process_gateway);
        curl_setopt($ch, CURLOPT_POST, $type);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data_arr));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        $response = curl_exec($ch);
        curl_close($ch);
        return $response;
    }

    function getNotifyHtml($status = 'pending',$insert_id = '1') {
        switch ($status) {
            case 'pending':
                $res = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>Payment result</title>
				<style type="text/css">
				*{
				font-family:"Microsoft Yahei","Arial";
				}
				body{
				background:#ECF0F1;
				}
				#system-message{
					height: 200px;
					width: 400px;
					margin-top: -100px;
					margin-left: -200px;
					position: absolute;
					left: 50%;
					top: 50%;
				}

				.pending {
				    padding: 0.3em 1em;
				    border-radius: 3px;
				    color: #fff;
					background: orange;
				}

				</style>

				</head>
				<body>
				<div id="system-message">

				<div class="pending">
				<b>Waiting！</b>Payment Pending.Your Order ID is:' . $insert_id . '
				</div>

				<p class="detail"></p>
				<p class="jump">
				<a href="">Go Back <<<</a>
				</p>
				</div>
				</body>
				</html>';
                break;

            case 'success':
                $res = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>Payment result</title>
				<style type="text/css">
				*{
				font-family:"Microsoft Yahei","Arial";
				}
				body{
				background:#ECF0F1;
				}
				#system-message{
					height: 200px;
					width: 400px;
					margin-top: -100px;
					margin-left: -200px;
					position: absolute;
					left: 50%;
					top: 50%;
				}

				.success {
				    padding: 0.3em 1em;
				    border-radius: 3px;
				    color: #fff;
					background: #2ECC71;
				}

				</style>

				</head>
				<body>
				<div id="system-message">

				<div class="success">
				<b>Congratulate！</b>Payment Success.Your Order ID is:' . $insert_id . '
				</div>

				<p class="detail"></p>
				<p class="jump">
				<a href="">Go Back <<<</a>
				</p>
				</div>
				</body>
				</html>';
                break;
            case 'decline':
                $res = '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
				<html xmlns="http://www.w3.org/1999/xhtml">
				<head>
				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
				<title>Payment result</title>
				<style type="text/css">
				*{
				font-family:"Microsoft Yahei","Arial";
				}
				body{
				background:#ECF0F1;
				}
				#system-message{
					height: 200px;
					width: 400px;
					margin-top: -100px;
					margin-left: -200px;
					position: absolute;
					left: 50%;
					top: 50%;
				}

				.decline {
				    padding: 0.3em 1em;
				    border-radius: 3px;
				    color: #fff;
					background: red;
				}

				</style>

				</head>
				<body>
				<div id="system-message">

				<div class="decline">
				<b>Sorry！</b>Payment Decline.Your Order ID is:' . $insert_id . '
				</div>

				<p class="detail"></p>
				<p class="jump">
				<a href="">Go Back <<<</a>
				</p>
				</div>
				</body>
				</html>';
                break;
            default:
                break;
        }
        return $res;
    }

}
